﻿using System;
using Unit4.CollectionsLib;
using System.Linq;
using System.Text;

namespace Tree
{
    class Program
    {
        //פעולה המדפיסה את כל הצמתים הזוגיים בעץ
        public static void PrintEven(BinTreeNode<int> t)
        {
            if (t != null)
            {
                if (t.GetInfo()%2==0)
                 Console.WriteLine(t.GetInfo());
                PrintEven(t.GetLeft());
                PrintEven(t.GetRight());
            }
        }

        //פעולה המדפיסה את העץ לפי סריקה תחילי
        public static void PrintTree(BinTreeNode<int> t)
        {
            if (t != null)
            {
                Console.WriteLine(t.GetInfo());
                PrintTree(t.GetLeft());
                PrintTree(t.GetRight());
            }
        }
        //פעולה המדפיסה את העץ לפי סריקה תחילי
        public static void PreOrder(BinTreeNode<int> t)
        {
            if (t != null)
            {
                Console.WriteLine(t.GetInfo());
                PrintTree(t.GetLeft());
                PrintTree(t.GetRight());
            }
        }

        //פעולה המדפיסה את העץ לפי סריקה תוכי
        public static void InOrder(BinTreeNode<int> t)
        {
            if (t != null)
            {
                PrintTree(t.GetLeft());
                Console.WriteLine(t.GetInfo());
                PrintTree(t.GetRight());
            }
        }

        //פעולה המדפיסה את העץ לפי סריקה סופי 
        public static void PostOrder(BinTreeNode<int> t)
        {
            if (t != null)
            {
                PrintTree(t.GetLeft());
                PrintTree(t.GetRight());
                Console.WriteLine(t.GetInfo());
            }
        }
       

        //פעולה המדפיסה את כל העלים השמאליים
        public static void PrintChildLeftIsLeaf(BinTreeNode<int> t)
        {
            if (t != null)
            {
                if (t.GetLeft() != null && IsLeaf(t.GetLeft()))//בן שמאלי וגם עלה
                    Console.WriteLine(t.GetLeft().GetInfo());
                PrintChildLeftIsLeaf(t.GetLeft());
                PrintChildLeftIsLeaf(t.GetRight());
            }
        }
        //n פעולה מדפיסה את הצמתים ברמה   
        public static void PrintLevel(BinTreeNode<int> t, int n)
        {
            if (t!=null)
            {
                if (n == 0)
                    Console.WriteLine(t.GetInfo());
                PrintLevel(t.GetLeft(), n - 1);
                PrintLevel(t.GetRight(), n - 1);
            }
        }
        //פעולה מחזירה מספר העלים בעץ
        public static int NumLeaf(BinTreeNode<int> t)
        {
            if (t == null)
                return 0;
            else if (IsLeaf(t))
                return 1;
            else return NumLeaf(t.GetLeft()) + NumLeaf(t.GetRight());
        }
        //פעולה מחזירה מספר הבנים הימניים בעץ
        public static int NumRightNode(BinTreeNode<int> t)
        {
            if (t == null)
                return 0;
            else if (t.GetRight() != null)
                return 1 + NumRightNode(t.GetLeft()) + NumRightNode(t.GetRight());
            else return NumRightNode(t.GetLeft());
        }
        //פעולה מחזירה מספר הצמתים שיש להם 2 בנים ושווים
        public static int NumFatherSonEqual(BinTreeNode<int> t)
        {
            if (t == null)
                return 0;
            else if (t.GetLeft()!= null && t.GetRight() != null &&
                t.GetLeft().GetInfo() == t.GetRight().GetInfo())
                return 1 + NumFatherSonEqual(t.GetLeft()) + NumFatherSonEqual(t.GetRight());
            else return NumFatherSonEqual(t.GetLeft()) + NumFatherSonEqual(t.GetRight());
        }
        //פעולה מחזירה מספר הצמתים שערכם קטן מערכו של ההורה שלהם
        public static int NumNodeLessFather(BinTreeNode<int> t)
        {
            int c,x;
            if (t == null)
                return 0;
            c = 0;
            x=t.GetInfo();
            if (t.GetLeft() != null && x > t.GetLeft().GetInfo())
                c++;
            if (t.GetRight() != null && x > t.GetRight().GetInfo())
                c++;
            return c + NumNodeLessFather(t.GetLeft()) + NumNodeLessFather(t.GetRight());

        }
        //פעולה מחזירה סכום הצמתים בעץ
        public static int SumNodes(BinTreeNode<int> t)
        {
            if (t == null)
                return 0;
            else return t.GetInfo() + SumNodes(t.GetLeft()) + SumNodes(t.GetRight());
        }
        //פעולה מחזירה אמת אם הצומת עלה אחרת תחזיר הפעולה שקר
        //public static bool IsLeaf(BinTreeNode<int> bt)
        //{
        //    return (bt.GetLeft() == null) && (bt.GetRight() == null);
        //}
        //פעולה מקבלת עץ ומחזירה את סכום הסאבים
        public static int SumGrandfather(BinTreeNode<int> t)
        {
            if (t == null)
                return 0;
            else if (t.GetLeft() != null && !IsLeaf(t.GetLeft())||
                     t.GetRight()!=null && !IsLeaf(t.GetRight()))
               return t.GetInfo() + SumGrandfather(t.GetLeft()) + SumGrandfather(t.GetRight());
            else return SumGrandfather(t.GetLeft()) + SumGrandfather(t.GetRight());
        }

        // n פעולה מחזירה מספר הצמתחים הנמצאים ברמה 
        public static int NumNodeLevel(BinTreeNode<int> t,int n)
        {
            if (t == null)
                return 0;
            else if (n == 0)
                return 1;
            else return NumNodeLevel(t.GetLeft(), n - 1) + NumNodeLevel(t.GetRight(), n - 1);
        }
        //פעולה מקבלת עץ ומחזירה אמת אם כל הצמתים הם זוגיים
        public static int SumLevel(BinTreeNode<int> t,int level)
        {
            if (t == null)
                return 0;
            if (level == 0)
                return t.GetInfo();
            return SumLevel(t.GetLeft(), level - 1) + SumLevel(t.GetRight(), level - 1);
        }
        //פעולה מחזירה אמת אם הצומת עלה אחרת תחזיר הפעולה שקר
        public static bool IsLeaf(BinTreeNode<int> bt)
        {
            return (bt.GetLeft() == null) && (bt.GetRight() == null);
        }
        //פעולה מקבלת עץ ומחזירה אמת אם העץ הוא תעלומה ושקר אחרת
        public static bool IsTaloma(BinTreeNode<int> t)
        {
            if (IsLeaf(t))//אם עלה
               return true;
            if (t.GetLeft() == null || t.GetRight() == null)
                return false;
            if (t.GetLeft().GetInfo() > 0)
                return false;
            if (t.GetRight().GetInfo() < 0)
                return false;
            return IsTaloma(t.GetLeft()) && IsTaloma(t.GetRight());
        }
        //פעולה מקבלת עץ ומחזירה אמת אם כל הצמתים בעץ זוגיים אחרת תחזיר שקר
        public static bool IsAllNodeEven(BinTreeNode<int> t)
        {
            if (t == null)
                return true;
            else if (t.GetInfo() % 2 != 0)
                return false;
            else return IsAllNodeEven(t.GetLeft()) && IsAllNodeEven(t.GetRight()); 
        }
      
        //פעולה מקבלת עץ ומחזירה אמת אם לכל צוממת יש שני ילדים
        public static bool EachHasTwoChild(BinTreeNode<int> t)
        {
            if (IsLeaf(t))//אם הצומת עלה
                return true;
            else if (t.GetLeft() == null || t.GetRight() == null)
                return false;
            else return EachHasTwoChild(t.GetLeft()) && EachHasTwoChild(t.GetRight());
        }
        //פעולה מחזירה אמת אם הצומת עלה אחרת תחזיר הפעולה שקר
        //public static bool IsLeaf(BinTreeNode<int> bt)
        //{
        //    return (bt.GetLeft() == null) && (bt.GetRight() == null);
        //}
        //פעולה מקבלת עץ ומחזירה אמת אם הוא עלה או שערך שורשו שווה לסכום ערכי בניו
        //וגם כל אחד מבניו מקיים את התכונה
        public static bool EqualTowChild(BinTreeNode<int> t)
        {
            if (IsLeaf(t))//אם צומת עלה
                return true;
            else if (t.GetLeft() == null || t.GetRight() == null)
                return false;
            else if (t.GetInfo() != t.GetLeft().GetInfo() + t.GetRight().GetInfo())
                return false;
            else return EqualTowChild(t.GetLeft()) && EqualTowChild(t.GetRight());
        }
        //פעולה מקבלת עץ ובןדקת האם עץ הוא עץ מאיר אחרת הפעולה תחזיר שקר
        //עץ נקרא מאיר לא ריק הוא עלה או שורש בעל שני בנים שכל אחד מהם הוא עץ מאיר
        //והפרש ערכי הבנים שלו אינו עולה על 2
        public static bool IsTreeMaeer(BinTreeNode<int> t)
        {
            if (t.GetLeft() == null && t.GetRight() == null)
                return true;
            else if (t.GetLeft() == null || t.GetRight() == null)
                return false;
            else if (Math.Abs(t.GetLeft().GetInfo() - t.GetRight().GetInfo()) > 2)
                return false;
            else return IsTreeMaeer(t.GetLeft()) && IsTreeMaeer(t.GetRight());
        }
        //פעולה מקבלת עץ ובודקת האם עץ הוא עץ יורד
        //עץ יורד הוא עלה או שורש ובן אחד,כך  שערך הבן אינו גדול מערך השורש
        //והבן עץ יורד
        public static bool IsTreeDown(BinTreeNode<int> t)
        {
            if (t.GetLeft() == null && t.GetRight() == null)
                return true;//עלה
            else if (t.GetLeft() != null && t.GetRight() != null)
                return false;//האם קיים 2 בנים
            else if (t.GetLeft() != null && t.GetInfo() < t.GetLeft().GetInfo())
                return false;
            else if (t.GetRight() != null && t.GetInfo() < t.GetRight().GetInfo())
                return false;
            else if (t.GetLeft() != null)
                return IsTreeDown(t.GetLeft());
            else return IsTreeDown(t.GetRight());
        }
        //פעולה מקבלת עץ ומחזירה אמת אם קיימים בעץ שני עלים שהם אחים
        //ושקר אחרת
        public static bool IsTwoChildLeaf(BinTreeNode<int> t)
        {
            if  ( t==null) 
                return false;
            if (t.GetLeft()!=null && IsLeaf(t.GetLeft()) && 
                t.GetRight()!=null && (IsLeaf(t.GetRight())))
                return true;
            return IsTwoChildLeaf(t.GetLeft()) || IsTwoChildLeaf(t.GetRight());
        }
        //פעולה בונה עץ
        public static BinTreeNode<int> CreatTree()
        {
            int x;
            x = int.Parse(Console.ReadLine());
            if (x == -1)
                return null;
            Console.WriteLine("Enter left of " + x + "(or enter -1 to null)");
            BinTreeNode<int> left = CreatTree();
            Console.WriteLine("Enter right of " + x + "(or enter -1 to null)");
            BinTreeNode<int> right = CreatTree();
            return new BinTreeNode<int>(left, x, right);
        }
        //פעולה מחזירה אמת אם הצומת עלה אחרת תחזיר הפעולה שקר
        //public static bool IsLeaf(BinTreeNode<int> bt)
        //{
        //    return (bt.GetLeft() == null) && (bt.GetRight() == null);
        //}
        // ,פעולה המוחקת את כל העלים בעץ
        public static void  RemoveAllLeaf(BinTreeNode<int> t)
        {
            if (t != null)
            {
                if (t.GetLeft() != null && IsLeaf(t.GetLeft()))
                {
                    t.SetLeft(null);
                }
                if (t.GetRight() != null && IsLeaf(t.GetRight()))
                {
                    t.SetRight(null);
                }
                RemoveAllLeaf(t.GetLeft());
                RemoveAllLeaf(t.GetRight());
            }
        }
        //פעולה מקבלת עץ ומוסיפה לכל בן יחיד אח  הערך שלו יהיה כמו הבן היחיד
        //אם לצומת עלה לא יתבצע דבר
        public static void InsertBrother(BinTreeNode<int> t)
        {
            if (t!=null)
            {
                if (t.GetLeft()==null&& t.GetRight()!=null)//בן יחיד ימני
                    t.SetLeft(new BinTreeNode<int>(t.GetRight().GetInfo()));
                if (t.GetRight()==null&& t.GetLeft()!=null)//בן יחיד שמאלי
                    t.SetRight(new BinTreeNode<int>(t.GetLeft().GetInfo()));
                InsertBrother(t.GetLeft());
                InsertBrother(t.GetRight());
            }
        }
        //פעולה מקבלת עץ ומחזירה אמת אם העץ מהווה עץ משולש ימני ואחרת שקר
        public static bool RightTreeTriangle(BinTreeNode<int> t)
        {
            if (IsLeaf(t)) //אם צומת עלה
                return true;
            if (t.GetLeft() == null || t.GetRight() == null)//בן יחיד
                return false;
            if (!IsLeaf(t.GetLeft()))//אם בן שמאלי לא עלה
                return false;
            return RightTreeTriangle(t.GetRight());
        }
        //פעולה מחזירה אמת אם הצומת עלה אחרת תחזיר הפעולה שקר
        //public static bool IsLeaf(BinTreeNode<int> bt)
        //{
        //    return (bt.GetLeft() == null) && (bt.GetRight() == null);
        //}
        //פעולה מקבלת עץ ומחזירה אמת אם קיים בעץ נכדים
        public static bool IsGrandson(BinTreeNode<int> t)
        {
            if (t==null|| IsLeaf(t))//אם הצומת עלה
                return false;
             if (t.GetLeft()!=null && !IsLeaf(t.GetLeft())||
                 t.GetRight()!= null && !IsLeaf(t.GetRight()))
                 return true;
             return IsGrandson(t.GetLeft()) || IsGrandson(t.GetRight());
        }
        //פעולה מחזירה אמת אם הצומת עלה אחרת תחזיר הפעולה שקר
        //public static bool IsLeaf(BinTreeNode<int> t)
        //{
        //    return (t.GetLeft() == null) && (t.GetRight() == null);
        //}
        //בגרות 2007
        //פעולה מקבלת עץ ומחזירה אמת אם קיים"מסלול-אחיד" אחרת תחזיר הפעולה שקר
        //הנחה:עץ לא ריק
        public static bool OnePath(BinTreeNode<int> t)
        {
            if (t == null)
                return false;
            if (IsLeaf(t))//אם צומת עלה
                return true;
            if (t.GetLeft()==null && t.GetRight()!=null && t.GetInfo()!=t.GetRight().GetInfo())
                return false;
            if (t.GetRight() == null && t.GetLeft() != null && t.GetInfo() != t.GetLeft().GetInfo())
                return false;
            if (t.GetLeft() != null && t.GetRight() != null &&
                t.GetLeft().GetInfo() != t.GetInfo() && t.GetRight().GetInfo() != t.GetInfo())
                return false;
            return OnePath(t.GetLeft()) || OnePath(t.GetRight());
        }
        
        //בגרות 2005 מועד מיוחד
        //הפעולה מקבלת עץ ומחזירה אמת אם העץ "רמה_בבנים" אחרת תחזיר הפעולה שקר
        //הנחה עץ לא ריק
        public static bool LevelChild(BinTreeNode<InfoLevel> t)
        {
            if (t==null)
                return true;
            if (t.GetLeft() != null && t.GetLeft().GetInfo().GetRoot()!=t.GetInfo().GetLevel())
                return false;
            if (t.GetRight() != null && t.GetRight().GetInfo().GetRoot() != t.GetInfo().GetLevel())
                return false;
            return LevelChild(t.GetLeft()) && LevelChild(t.GetRight());
        }
        //פעולה מחזירה אמת אם הצומת עלה אחרת תחזיר הפעולה שקר
        //public static bool IsLeaf(BinTreeNode<int> bt)
        //{
        //    return (bt.GetLeft() == null) && (bt.GetRight() == null);
        //}
        //בגרות 2005
        // הפעולה מוסיפה בן ימניn -לכל עלה בעץ שערכו גדול מ n פעולה מקבלת עץ לא ריקה ומספר
        //n שערכו שווה ל
        public static void InsertLeaf(BinTreeNode<int> t, int n)
        {
            if (t != null)
            {
                if (IsLeaf(t) && t.GetInfo()>n)
                {
                    t.SetRight(new BinTreeNode<int>(n));
                }
                InsertLeaf(t.GetLeft(),n);
                InsertLeaf(t.GetRight(),n);
            }
        }
        //פעולה מקבלת 2 עצים ומחזירה אמת אם שני העצים דומים בתוכן וגם במבנה
        public static bool IsEqual(BinTreeNode<int> t1, BinTreeNode<int> t2)
        {
            if (t1 == null && t2 == null)
                return true;
            if (t1.GetInfo() != t2.GetInfo())
                return false;
            if (t1.GetLeft() != null && t2.GetLeft() == null)
                return false;
            if (t1.GetLeft() == null && t2.GetLeft() != null)
                return false;
            if (t1.GetRight() == null && t2.GetRight() != null)
                return false;
            if (t1.GetRight() != null && t2.GetRight() == null)
                return false;
            return IsEqual(t1.GetLeft(), t2.GetLeft()) &&
                   IsEqual(t1.GetRight(), t2.GetRight());
        }
        //t2 מוכל בתוך העץ t1 פעולה מקבלת 2 עצים ומחסירה אמת אם העץ
        public static bool IsContained(BinTreeNode<int> t1, BinTreeNode<int> t2)
        {
            if (t1 == null)
                return true;
            if (t2 == null)
                return false;
            if (IsEqual(t1, t2))
                return true;
            return IsContained(t1, t2.GetLeft()) || IsContained(t1, t2.GetRight());
        }
      
        //פעולה מחזיר את האיבר המקסימאלי בין 3 מספרים
        public static int Max3(int x, int y, int z)
        {
            return Math.Max(Math.Max(x, y), z);
        }
        //פעולה מקבלת עץ ומחזירה את האיבר המקסימאלי בעץ
        public static int GetMax(BinTreeNode<int> t)
        {
            if (IsLeaf(t))//צומת עלה
                return t.GetInfo();
            if (t.GetLeft() == null)
                return Math.Max(t.GetInfo(),GetMax(t.GetRight()));
            if (t.GetRight() == null)
                return Math.Max(t.GetInfo(), GetMax(t.GetLeft()));
            return Max3(t.GetInfo(),GetMax(t.GetLeft()),GetMax(t.GetRight()));
        }
        //פעולה מחזירה אמת אם מספר נמצא בעץ אחרת מחזירה הפעולה שקר
        public static bool Found(BinTreeNode<int> t, int X)
        {
            if (t == null)
                return false;
            if (t.GetInfo() == X)
                return true;
            return Found(t.GetLeft(), X) || Found(t.GetRight(), X);
        }
        //פעולה מקבלת 2 עצים לא ריקים ובונה רשימת האיברים המשותפים לשני העצים
        public static void BuildList(BinTreeNode<int> t1, BinTreeNode<int> t2, List<int> lst)
        {
            if (t1 != null)
            {
                if (Found(t2, t1.GetInfo()))
                    lst.Insert(null, t1.GetInfo());
                BuildList(t1.GetLeft(), t2, lst);
                BuildList(t1.GetRight(), t2, lst);
            }
        }
        //פעולה מקבלת 2 עצים לא ריקים ומחזירה רשימה של האיברים המשותים
        public static List<int> CommonNodes(BinTreeNode<int> t1, BinTreeNode<int> t2)
        {
            List<int> list = new List<int>();
            BuildList(t1, t2, list);
            return list;
        }
        //פעולה מקבלת עץ ומדפיסה את הצמתים לפי רמות
        public static void LevelOrder(BinTreeNode<int> t)
        {
            Queue<BinTreeNode<int>> q = new Queue<BinTreeNode<int>>();
            BinTreeNode<int> bt;
            q.Insert(t);
            while (!q.IsEmpty())
            {
                bt = q.Remove();
                Console.WriteLine(bt.GetInfo());
                if (bt.GetLeft() != null)
                    q.Insert(bt.GetLeft());
                if (bt.GetRight() != null)
                    q.Insert(bt.GetRight());
            }
        }
        // ושקר אחרת y  והוא צאצא של צומת x פעולה מקבלת עץ ומחזירה אמת אם קיים צומת
        public static bool Descendant(BinTreeNode<int> t,int x,int y)
        {
            if (t.GetInfo() == y)
                return Found(t.GetLeft(), x) || Found(t.GetRight(), x);
            return Descendant(t.GetLeft(), x, y) || Descendant(t.GetRight(), x, y);
        }
        //פעולה מקבלת עץ הפעולה מחזירה סכום הערכים של כל רמה בעץ לרשימה חדשה
        public static List<int>  LevelOrderSumList(BinTreeNode<int> t)
        {
            List<int> list = new List<int>();
            Node<int> pos = list.GetFirst();
            Queue<BinTreeNode<int>> q1 = new Queue<BinTreeNode<int>>();
            Queue<BinTreeNode<int>> q2 = new Queue<BinTreeNode<int>>();
            BinTreeNode<int> bt;
            q1.Insert(t);
            while (!q1.IsEmpty() || !q2.IsEmpty())
            {
                int sum = 0;
                if (!q1.IsEmpty())
                    while (!q1.IsEmpty())
                    {
                        bt = q1.Remove();
                        sum = sum + bt.GetInfo();
                        if (bt.GetLeft() != null)
                            q2.Insert(bt.GetLeft());
                        if (bt.GetRight() != null)
                            q2.Insert(bt.GetRight());
                    }
                else 
                    while (!q2.IsEmpty())
                    {
                        bt = q2.Remove();
                        sum = sum + bt.GetInfo();
                        if (bt.GetLeft() != null)
                            q1.Insert(bt.GetLeft());
                        if (bt.GetRight() != null)
                            q1.Insert(bt.GetRight());
                    }  
                pos = list.Insert(pos, sum);
            }
            return list;
        }
        
        //פעולה מקבלת עץ ומדפיסה את את הצמתים שגדולים מהבנים שלהם
        public static void PrintPernt(BinTreeNode<int> t)
        {
            if (t != null)
            {
                //קיים שני בנים וההורה גדול מהבנים
                if (t.GetLeft() != null && t.GetLeft().GetInfo() < t.GetInfo()
                    && t.GetRight() != null && t.GetRight().GetInfo() < t.GetInfo())
                    Console.WriteLine(t.GetInfo());
                //קיים בין יחיד שמאלי והוא קטו מהורה
                if (t.GetLeft()!=null && t.GetRight()==null&&
                    t.GetInfo() > t.GetLeft().GetInfo())
                    Console.WriteLine(t.GetInfo());
                //קיים בין יחיד ימני והוא קטו מהורה
                if (t.GetRight() != null && t.GetLeft() == null 
                    && t.GetInfo() > t.GetRight().GetInfo())
                    Console.WriteLine(t.GetInfo());
                PrintPernt(t.GetLeft());
                PrintPernt(t.GetRight());
            }
        }

        //2. גירסה לא רקורסיבית המשתמשת בתור - סריקה לפי רמות
        public static BinTreeNode<int> Parent2(BinTreeNode<int> bt, BinTreeNode<int> child)
        {
            BinTreeNode<int> t;
            Queue<BinTreeNode<int>> q = new Queue<BinTreeNode<int>>();

            q.Insert(bt);
            while (!q.IsEmpty())
            {
                t = q.Remove();
                if (t.GetLeft() == child || t.GetRight() == child)
                    return t;
                if (t.GetLeft() != null)
                    q.Insert(t.GetLeft());
                if (t.GetRight() != null)
                    q.Insert(t.GetRight());
            }
            return null;
        }
      
        //בגרות 2005
        public static void Add(BinTreeNode<int> t, int n)
        {

            if (t != null)
            {

                if (IsLeaf(t) == true)
                {
                    if (t.GetInfo() > n)
                        t.SetRight(new BinTreeNode<int>(n));
                }
                Add(t.GetLeft(), n);
                Add(t.GetRight(), n);
            }
        }

        //פעולה מקבלת עץ ומחזירה אמת אם העץ פרו ורבו אחרת יוחזר שקר
        public static bool ProRbo(BinTreeNode<int> t)
        {
            if (t == null)
                return false;
            if (t.GetLeft() != null && !IsLeaf(t.GetLeft()) &&
                t.GetRight() != null && !IsLeaf(t.GetRight()))
                return true;
            return ProRbo(t.GetLeft()) || ProRbo(t.GetLeft());
        }
        //פעולה מחזירה גובה עץ
        //הנחה עץ לא ריק ואם העץ ריק יוחזר -1
        public static int Height(BinTreeNode<int> t)
        {
            if (t == null)
                return -1;

           return 1+ Math.Max(Height(t.GetLeft()),Height(t.GetRight()));
        }
        //פעולה מחזירה הורה
        public static BinTreeNode<int> Parent1(BinTreeNode<int> bt, BinTreeNode<int> child)
        {
            if ((bt == null) || (child == bt.GetLeft()) || (child == bt.GetRight()))
                return bt;

            BinTreeNode<int> node = Parent1(bt.GetLeft(), child);

            if (node == null)
                return Parent1(bt.GetRight(), child);
            else
                return node;
        }


        //פעולה מחזירה סכום הצמתים בעץ
        //public static int SumNodes(BinTreeNode<int> t)
        //{
        //    if (t == null)
        //        return 0;
        //    else return t.GetInfo() + SumNodes(t.GetLeft()) + SumNodes(t.GetRight());
        //}
        //פעולה מקבלת עץ ומחזירה אמת אם העץ הוא עץ סכומים אחרת יוחזר שקר
        public static bool IsTreeSum(BinTreeNode<int> t)
        {
            if (t==null|| IsLeaf(t))
                return true;
            if (t.GetInfo() != SumNodes(t.GetLeft())+SumNodes(t.GetRight()))
                return false;
            return IsTreeSum(t.GetLeft()) && IsTreeSum(t.GetRight());
        }

        static void Main(string[] args)
        {
           
            
            Console.WriteLine("Enter info Root");
            BinTreeNode<int> t = CreatTree();
            
            //Console.WriteLine("Enter info Root");
            //BinTreeNode<int> t2 = CreatTree();
            //Console.WriteLine(IsContained(t, t2));
            //BinTreeNode<int> child = t.GetLeft().GetRight();
            //Console.WriteLine(Parent1(t, child));
            //Console.WriteLine(IsGrandson(t));
            //Console.WriteLine(IsTreeSum(t));
           // PrintTree(t);
            //BinTreeNode<int> t = CreatTree();
            //Console.WriteLine("Enter info Root");
            //BinTreeNode<int> t2 = CreatTree();
            //Console.WriteLine(IsEqual(t, t2));
            //Console.WriteLine(NumRightNode(t));
            //Console.WriteLine(NumLeaf(t));
            //Console.WriteLine(NumFatherSonEqual(t));
            //Console.WriteLine(NumNodeLessFather(t));
            //Console.WriteLine(SumNodes(t));
            //Console.WriteLine(NumNodeLevel(t, 1));
            //Console.WriteLine(EachHasTwoChild(t));
            //Console.WriteLine(IsAllNodeEven(t));
            //Console.WriteLine(IsTreeMaeer(t));
            //Console.WriteLine(IsTreeDown(t));
            //Console.WriteLine(IsTwoChildLeaf(t));
            //RemoveAllLeaf(ref t);
            //InsertBrother(t);
            //PrintTree(t);
            //Console.WriteLine(OnePath(t));
            //PrintChildLeftIsLeaf(t);
            //PrintLevel(t, 2);
            //Console.WriteLine(SumLevel(t, 2));
            //Console.WriteLine(GetMax(t));
            //Console.WriteLine(CommonNodes(t, t2)); ;
            //LevelOrder(t);
            //Console.WriteLine(LevelOrderSumList(t));
            //InsertLeaf(t, 7);
            //PrintTree(t);
            //Console.WriteLine(Descendant(t, 13, 5));
            //BinTreeNode<int> pos = t.GetRight().GetRight();
            //Console.WriteLine(Parent1(t,pos));
            //PrintPernt(t);
            //Add(t, 7);
            //PrintTree(t);
            //Console.WriteLine(Height(t));
        }
    }
}
